﻿using System;
using System.Windows.Forms;
using Misure;

namespace ConvertitoreMisure
{
    public partial class Form1Convertitore : Form
    {
        double temperatura;
        string UnitTempIn;

        public Form1Convertitore()
        {
            InitializeComponent();
        }

        private void LoadingForm(object sender, EventArgs e)
        {
            int i = 0;

            // Inizializa la ComboBox per la lista delle Temperature
            ComboBoxInT.Items.AddRange(Temperature.NameUnitTemp);


            // Inabilita le textBox per le temperature convertite
            // I nomi delle TextBox devono essere le prime 8 in ordine alfabetico
            foreach (Control item in Controls)
            {
                if (item is TextBox)
                {
                    item.Enabled = false;
                    if (i++ == 7)
                        return;
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Verifica che l'unita' di misura della temperatura sia scelta
            if (ComboBoxInT.SelectedIndex == -1)
            {
                MessageBox.Show("Scegliere Le unita'di Misura");
                return;
            }
            else
            {
                // Memorizzo l'indice relativo all'unità di misura
                UnitTempIn = Temperature.Simboli[ComboBoxInT.SelectedIndex];
            }

            string contenuto = (valueInput.Text.ToString()).Replace('.', ',');
            bool verifica = Double.TryParse(contenuto, out temperatura);

            if (!verifica)
            {
                valueInput.Clear();
                valueInput.BackColor = System.Drawing.Color.Red;
                valueInput.Text = "VALORE NON NUMERICO";
                return;
            }
            if (!Temperature.ValiateTemp(UnitTempIn, temperatura))
            {
                MessageBox.Show("Valore fuori scala");
                return;
            };

            Temperature value = new Temperature(UnitTempIn, temperatura);

            double[] result = new double[8];

            int i = 0;
            foreach (string simbol in Temperature.Simboli)
            {
                if (i > Temperature.Simboli.Length)
                    return;

                result[i++] = Math.Round(value.ConvertTemp(simbol), 3);
            }


            i = 0;
            foreach (Control txb in Controls)
            {
                if ((txb is TextBox) && i < 8)
                {
                    txb.Text = result[i++].ToString();
                }
            }
        }

        // Enter
        private void Evidenzia(object sender, EventArgs e)
        {
            valueInput.SelectAll();
        }

        private void toolTipValueTemp_Popup(object sender, PopupEventArgs e)
        {
            toolTipValueTemp.Show("casetta", valueInput, 25000);
        }
    }
}
